//	GetPass 7.1 - C_FILTER for F6FBB BBS Software
//  	Written by Marco Savegnago IW3FQG

#ifndef	__GPPASS_H
#define	__GPPASS_H

#include	<fstream.h>

#define	PT_MTX	0x01
#define	PT_MD2	0x02
#define	PT_RSA	0x04

class	Password
{
	char					sz_passwordFilename[MAXPATH];
	char*					psz_callsign;
	PasswordString* 	passwordString;
#ifdef	__INC_RSA
	R_RSA_PRIVATE_KEY privateKey;
#endif   
	bool						b_rsaFound;
	bool						b_stdFound;

	char*						psz_challenge;
	word						w_passwordFlags;
	static	char			sz_NOMD2[];
	static	char			sz_NOMTX[];
	static	char			sz_NORSA[];
	int	checkRSAHeader(char* psz_EncodedBlockIn);

#ifdef	__INC_RSA
	int	readPrivateKey(char* psz_EncodedBlockIn, R_RSA_PRIVATE_KEY* p_privateKey);
#endif
public:

	int 	ReadPassword();
	Password( const char *cpsz_Callsign, const char* cpsz_PasswordFilename);
	~Password();
	int MakeReply(char* psz_challenge, ostream&	ostream);
};

#endif	//	#define	__GPPASS_H
